
DEFINE xlapp INTEGER
DEFINE xlwb  INTEGER
define sb base.stringbuffer,
       i, j         INTEGER,
       nrows, ncols INTEGER,
       a    dynamic ARRAY WITH DIMENSION 2 OF INTEGER
DEFINE anfang, ende DATETIME MINUTE TO FRACTION       

DEFINE result     INTEGER
DEFINE str        STRING,
       tabs, crlf CHAR(1),
       wert       INTEGER,
       zeile      INTEGER

MAIN
  LET tabs = ascii(9)
  LET crlf = ascii(10)

-----------------------------------------------
  --part of GDC Online Documentation
  --initialization of global variables
  LET xlapp = -1
  LET xlwb = -1

  --first, we must create an Instance of an Excel Application
  CALL ui.Interface.frontCall("WinCOM", "CreateInstance", ["Excel.Application"], [xlapp])
  CALL CheckError(xlapp, __LINE__)
  --then adding a Workbook to the current document
  CALL ui.interface.frontCall("WinCOM", "CallMethod", [xlapp, "WorkBooks.Add"], [xlwb])
  CALL CheckError(xlwb, __LINE__)
  --then, setting it to be visible
  CALL ui.interface.frontCall("WinCOM", "SetProperty", [xlapp, "Visible", true], [result])
  CALL CheckError(result, __LINE__)
  --then CALL SetProperty to set the value of the cell
  CALL ui.Interface.frontCall("WinCOM", "SetProperty", [xlwb, "activesheet.Range(\"A1\").Value", "foo"],[result])
  CALL ui.Interface.frontCall("WinCOM", "SetProperty", [xlwb, "activesheet.Range(\"B1\").Value", "FooFoo"],[result])
  CALL CheckError(result, __LINE__)
  --then CALL GetProperty to check the value again
  CALL ui.Interface.frontCall("WinCOM", "GetProperty", [xlwb, "activesheet.Range(\"A2\").Value"], [str])
  CALL CheckError(str, __LINE__)
  DISPLAY "content of the cell is: " || str


# empty clipboard
  CALL ui.Interface.FrontCall("standard","cbclear","",result)

# create StringBuffer
  LET sb = base.StringBuffer.create()

  let anfang = current
  let nrows = 25
  let ncols = 10
  FOR i = 1 TO nrows
    FOR j = 1 TO ncols      # fill one row with values and tabs
        let a[i, j] = i * j
        if i mod 2 = 0 then
           let a[i, j] = a[i, j] * -1
        end if
        CALL sb.append( a[i, j] )
        CALL sb.append( tabs )
    END FOR
    CALL sb.append( crlf )       # new line
  END FOR
  let ende = current
  display "Start " || anfang
  display "Ende  " || ende

   CALL ui.interface.frontcall("WinCOM", "CallMethod",  [xlapp, 'Range("M1").Select'], [result])
   CALL ui.interface.frontcall("WinCOM", "SetProperty", [xlapp, "Selection.HorizontalAlignment", "xlright"], [result])
   CALL ui.interface.frontcall("WinCOM", "SetProperty", [xlapp, "Selection.Font.ColorIndex", "5"], [result])
   CALL ui.interface.frontcall("WinCOM", "SetProperty", [xlapp, "Selection.Value", "Summe"], [result])
   FOR i = 1 to nrows +  1
     # backgroud color for complete row
     # LET str = "Rows(\"", i using "<<<<", "\").Select"
     # backgroud color for range
       LET str = "Range(\"A", i using "<<<<", ":J", i using "<<<<<", "\").Select"
       CALL ui.interface.frontcall("WinCOM", "CallMethod", [xlapp, str], [result])
       CALL ui.interface.frontcall("WinCOM", "CallMethod", [xlapp, str], [result])
       CALL ui.interface.frontcall("WinCOM", "SetProperty", [xlapp, "Selection.Interior.ColorIndex", i], [result])

       LET str = "Range(\"M", i using "<<<<", "\").Select"
       CALL ui.interface.frontcall("WinCOM", "CallMethod", [xlapp, str], [result])

       IF i > 1 THEN
        # apply a formula ( german formula "Summe" )
          LET str = "=Summe(A", i using "<<<<<", ":J", i using"<<<<<", ")"
          CALL ui.interface.frontcall("WinCOM", "SetProperty", [xlapp, "Selection.Formula", str ], [result])
       END IF
   END FOR
      
  CALL ui.interface.frontcall("WinCOM", "CallMethod", [xlapp, 'Columns("M").Select'], [result])
  CALL ui.Interface.frontCall("WinCOM", "SetProperty", [xlapp, "Selection.Font.Bold", true],[result])

# copy StringBuffer to clipboard
  CALL ui.Interface.FrontCall("standard","cbadd",sb.toString(),result)

# paste clipboard into workbook
  CALL ui.interface.frontcall("WinCOM", "CallMethod", [xlapp, 'Range("A2").Select'], [result])
  CALL CheckError(result, __LINE__)
  CALL ui.interface.frontcall("WinCOM", "CallMethod", [xlapp, "activesheet.Paste"], [result])
  CALL CheckError(result, __LINE__)

# set fontsize in rows 1 and 2
  CALL ui.interface.frontcall("WinCOM", "CallMethod", [xlapp, 'Range("A1:J2").Select'], [result])
  CALL CheckError(result, __LINE__)

  CALL ui.interface.frontcall("WinCOM", "SetProperty", [xlapp, "Selection.Font.Size", "12"], [result])
  CALL CheckError(result, __LINE__)

# borders in rows 1 and 2 
# ( not yet solved: border around the whole selection
#   instead of each cell )
  CALL ui.interface.frontcall("WinCOM", "SetProperty", 
       [xlapp, "Selection.Borders.LineStyle", "1"], [result])
  CALL CheckError(result, __LINE__)

  CALL ui.interface.frontcall("WinCOM", "SetProperty", 
       [xlapp, "Selection.Borders.Weight", "4"], [result])
  CALL CheckError(result, __LINE__)

# fixed column width
  call ui.Interface.frontCall("WinCOM", "SetProperty", [xlwb, "activesheet.Columns(\"A:M\").ColumnWidth", "10"],[result])
# or AutoFit
# call ui.Interface.frontCall("WinCOM", "SetProperty", [xlwb, "activesheet.Columns(\"A:M\").AutoFit", "0"],[result])


----------------------------------------
# fix first line
  CALL ui.interface.frontcall("WinCOM", "CallMethod", [xlapp, 'Rows("2:2").Select'], [result])
  CALL CheckError(result, __LINE__)
  CALL ui.interface.frontcall("WinCOM", "SetProperty", [xlapp, "ActiveWindow.FreezePanes", "True"], [result])
  CALL CheckError(result, __LINE__)
  CALL ui.interface.frontcall("WinCOM", "CallMethod", [xlapp, 'Range("A1").Select'], [result])
  CALL CheckError(result, __LINE__)
---------------------------------------

  --then Free the memory on the client side
  CALL freeMemory()
END MAIN

FUNCTION freeMemory()
  DEFINE res INTEGER
  IF xlwb != -1 THEN
    CALL ui.Interface.frontCall("WinCOM","ReleaseInstance", [xlwb], [res] )
  END IF
  IF xlapp != -1 THEN
    CALL ui.Interface.frontCall("WinCOM","ReleaseInstance", [xlapp], [res] )
  END IF
END FUNCTION

FUNCTION checkError(res, lin)
  DEFINE res INTEGER
  DEFINE lin INTEGER
  DEFINE mess STRING

  IF res = -1 THEN
    DISPLAY "COM Error for call at line:", lin
    CALL ui.Interface.frontCall("WinCOM","GetError",[],[mess])
    DISPLAY mess
    --let's release the memory on the GDC side
    CALL freeMemory()
    DISPLAY "Exit with COM Error."
    EXIT PROGRAM (-1)
  END IF
END FUNCTION


